(*
 Si consideri la Sintassi Astratta sotto, per il Lambda Calcolo:
    	Lambda::= Var | Const | [$] Var Lambda | [@] Lambda Lambda
 dove usiamo $ per l'astrazione e @ per l'applicazione.
 Si chiede di fornire in Ocaml strutture, tipi, operazioni per la
 costruzione, l'accesso e la presentazione degli Abstract Syntax
 Tree dei termini del Linguaggio del Lambda Calcolo.
 In particolare, le operazioni richieste devono includere:
 mkConst, mkVar, mkAbs, mkApp,
 isConst, isVar, isAbs, isApp
 getIde, getTem, getFun, getArg
 printAST (per la presentazione degli AST)
 printCRT (per la presentazione nella sitassi concreta, vedi Lezioni, 
 		   degli AST)
*)

(*
 Questo modulo e' il corrispettivo del modulo header della versione 
 fornita in C, vedi modulo Last.h
*)

(* Definizione del tipo last: iniziale nome minuscola *)
(* Tipi Algebrici: iniziale nome costruttore Maiuscola *)

type last = Var of string 
			| Const of string 
			| Abs of string * last
			| App of last * last
			;;

(* segnatura operazioni in OCaml solo moduli di tipi astratti *)
